import request from '@/utils/request';
import type {ApiResult, PageResult} from '@/api';
import type {ContractEquipment, ContractEquipmentParam} from './model';

/**
 * 分页查询合同设备
 */
export async function pageContract(params: ContractEquipmentParam) {
  const res = await request.get<ApiResult<PageResult<ContractEquipment>>>(
    '/tower/tower-contract-equipment/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询合同设备列表
 */
export async function listContractEquipment(params?: ContractEquipmentParam) {
  const res = await request.get<ApiResult<ContractEquipment[]>>(
    '/tower/tower-contract-equipment',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询合同设备
 */
export async function getContractEquipment(id: number) {
  const res = await request.get<ApiResult<ContractEquipment>>(
    '/tower/tower-contract-equipment/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加合同设备
 */
export async function addContractEquipment(data: ContractEquipment) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-contract-equipment',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改合同设备
 */
export async function updateContractEquipment(data: ContractEquipment) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-contract-equipment',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量修改合同设备
 */
export async function updateBatchContractEquipment(data: ContractEquipment[]) {
  const res = await request.put<ApiResult<unknown>>(
    '/tower/tower-contract-equipment/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量添加合同设备
 */
export async function addBatchContractEquipment(data: ContractEquipment[]) {
  const res = await request.post<ApiResult<unknown>>(
    '/tower/tower-contract-equipment/batch',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除合同设备
 */
export async function removeContractEquipment(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-contract-equipment/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除合同设备
 */
export async function removeBatchContractEquipment(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    '/tower/tower-contract-equipment/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}
